---
title: Edit Shape Paths in CSS
slug: Tools/Page_Inspector/How_to/Edit_CSS_shapes
tags:
  - CSS
  - DevTools
  - Page Inspector
  - Rules view
  - Tools
  - highlighter
  - shapes
---
<div>{{ToolsSidebar}}</div>

<p class="summary">The Shape Path Editor is a tool that helps you see and edit shapes created using {{cssxref("clip-path")}} and also the CSS {{cssxref("shape-outside")}} property and {{cssxref("&lt;basic-shape&gt;")}} values. This guide walks you through all of the available options.</p>

<h2 id="Activate_deactivate_the_Shape_Path_Editor">Activate / deactivate the Shape Path Editor</h2>

<p>The Shape Path Editor is accessed via the CSS Rules Panel, which can be opened as described in the guide to <a href="/en-US/docs/Tools/Page_Inspector/How_to/Open_the_Inspector">Opening the Inspector</a>. Once you have selected your element, you should see the shape icon alongside any valid value, e.g. one for <code>shape-outside</code>.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/15915/enable-shapes-editor.png" style="border-style: solid; border-width: 1px; height: 370px; width: 1836px;"></p>

<p>Clicking the icon will cause the Editor to highlight the shape.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/15916/circle.png" style="height: 686px; width: 1210px;"></p>

<p>To deactivate the Shape Path Editor click on the icon again, or select another element or a different editor. Note that the Shape Path Editor does not persist between page reloads — if you reload your page you will need to select the element again.</p>

<h2 id="Understanding_the_lines_drawn_by_the_editor">Understanding the lines drawn by the editor</h2>

<p>Once you have selected a shape on your page, the Shape Path Editor will draw lines to help you understand the path that is being created.</p>

<ul>
 <li><strong>A solid line</strong> shows the outline of the shape that is wrapping the text. This is your shape. If the shape is clipped by the margin box then the margin box will make up part of this line.</li>
 <li><strong>A dashed line </strong>demonstrates the outline of the shape which extends past the margin box reference; this is the area that will be clipped by the margin box. To understand the margin box, and other boxes used by CSS Shapes see our guide to <a href="/en-US/docs/Web/CSS/CSS_Shapes/From_box_values">Shapes from box values</a>.</li>
</ul>

<p><img alt="" src="https://mdn.mozillademos.org/files/15917/clipped-margin-box.png" style="height: 692px; width: 1290px;"></p>

<h2 id="Editing_Basic_Shapes">Editing Basic Shapes</h2>

<p>The options given to you by the tool will differ depending on the type of basic shape that you are editing. Options can be accessed by activating the Shape Path Editor with a regular click on the icon, and you can use the context menu (<kbd>Ctrl</kbd>/<kbd>Cmd</kbd> + click) to access additional functionality.</p>

<h3 id="circle()">circle()</h3>

<p>If the value of <code>shape-outside</code> is <code>circle()</code>, you are creating a <a href="/en-US/docs/Web/CSS/CSS_Shapes/Basic_Shapes#circle()">circle basic shape</a>. Clicking on the shapes icon next to the value of <code>circle()</code> will highlight the shape, and also give you the option to resize the circle or move its center. If you move or resize the circle past the margin box, the edges become clipped by it.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/15917/clipped-margin-box.png" style="height: 692px; width: 1290px;"></p>

<p>In the Rules Panel you can see the values for <code>circle()</code> change as you edit the shape. You can then copy these values back into your stylesheet to create the new, tweaked shape path.</p>

<h3 id="ellipse()">ellipse()</h3>

<p>If the value of <code>shape-outside</code> is <code>ellipse()</code> then you are using the <a href="/en-US/docs/Web/CSS/CSS_Shapes/Basic_Shapes#ellipse()">ellipse basic shape</a>. The <code>ellipse()</code> value works in much the same way as <code>circle()</code> in the Shape Path Editor. An ellipse is a squashed circle and therefore has the option to resize horizontally and vertically when you click on the shapes icon.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/15920/ellipse.png" style="height: 570px; width: 1216px;"></p>

<h3 id="inset()">inset()</h3>

<p>If the value of <code>shape-outside</code> is <code>inset()</code> then you are using the <a href="/en-US/docs/Web/CSS/CSS_Shapes/Basic_Shapes#inset()">inset basic shape</a>, which enables the creation of offset values pulling the content in from the margin box.</p>

<p>Each side of the rectangle can be targeted after clicking on the shapes icon to activate the Shape Path Editor, and dragging each side will update the values for the top, right, bottom, and left offset values.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/15923/inset.png" style="height: 606px; width: 1214px;"></p>

<h3 id="polygon()">polygon()</h3>

<p>If the value of <code>shape-outside</code> is <code>polygon()</code> then you are using the <a href="/en-US/docs/Web/CSS/CSS_Shapes/Basic_Shapes#polygon()">polygon basic shape</a>. This is the most complex of the basic shape values, therefore the tool gives you more options when editing these:</p>

<ul>
 <li>Clicking on the shapes icon will activate the Shapes Path Editor and give you the option to move any of the points of your polygon shape.</li>
 <li>Double-click anywhere on a line of the shape and you will get a new point to adjust.</li>
 <li>Double click on an existing point and it will be removed. <em>Remember that a polygon needs at least three points</em>.</li>
</ul>

<p><img alt="" src="https://mdn.mozillademos.org/files/15918/polygon-edit.png" style="height: 660px; width: 1260px;"></p>

<h3 id="Moving_and_scaling_shapes">Moving and scaling shapes</h3>

<p>There is extra functionality available on the shape highlight — if you <kbd>Ctrl</kbd>/<kbd>Cmd</kbd> + click on the shapes icon for your shape the highlight will change, instead providing the ability to scale and/or move it. Once again, clipping will occur if you exceed the bounds of the margin box.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/15924/scaled-circle.png"></p>

<p>If your shape is a polygon, you also get the ability to rotate it around an axis.</p>

<h2 id="Browser_support">Browser support</h2>

<p>The Shape Path Editor currently works for shapes generated via {{cssxref("clip-path")}}; it will also work for shapes generated via {{cssxref("shape-outside")}} as of Firefox 62.</p>
